Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3569)
@@ -1570,8 +1826,8 @@
 !> Value of perct is the Perceived Temperature, degree centigrade
 !------------------------------------------------------------------------------!
- SUBROUTINE calculate_perct_static( ta, vp, ws, tmrt, pair, clo, perct )
+ SUBROUTINE calculate_perct_static( ta, vp, ws, tmrt, pair, clo, perct_ij )
 
     IMPLICIT NONE
-
+!
 !-- Type of input of the argument list
     REAL(wp), INTENT ( IN )  :: ta   !< Local air temperature (degC)
@@ -1580,13 +1836,13 @@
     REAL(wp), INTENT ( IN )  :: ws   !< Local wind velocitry (m/s)
     REAL(wp), INTENT ( IN )  :: pair !< Local barometric air pressure (hPa)
-
+!
 !-- Type of output of the argument list
-    REAL(wp), INTENT ( OUT ) :: perct   !< Perceived temperature (degC)
-    REAL(wp), INTENT ( OUT ) :: clo     !< Clothing index (dimensionless)
-
+    REAL(wp), INTENT ( OUT ) :: perct_ij  !< Perceived temperature (degC)
+    REAL(wp), INTENT ( OUT ) :: clo       !< Clothing index (dimensionless)
+!
 !-- Parameters for standard "Klima-Michel"
     REAL(wp), PARAMETER :: eta = 0._wp  !< Mechanical work efficiency for walking on flat ground (compare to Fanger (1972) pp 24f)
     REAL(wp), PARAMETER :: actlev = 134.6862_wp !< Workload by activity per standardized surface (A_Du)
-
+!
 !-- Type of program variables
     REAL(wp), PARAMETER :: eps = 0.0005  !< Accuracy in clothing insulation (clo) for evaluation the root of Fanger's PMV (pmva=0)
@@ -1614,20 +1870,23 @@
 
     LOGICAL :: sultrieness
-
+!
 !-- Initialise
-    perct = 9999.0_wp
+    perct_ij = bio_fill_value
 
     nerr     = 0_iwp
     ncount   = 0_iwp
     sultrieness  = .FALSE.
+!
 !-- Tresholds: clothing insulation (account for model inaccuracies)
+!
 !   summer clothing
     sclo     = 0.44453_wp
+!
 !   winter clothing
     wclo     = 1.76267_wp
-
+!
 !-- decision: firstly calculate for winter or summer clothing
     IF ( ta <= 10._wp ) THEN
-
+!
 !--    First guess: winter clothing insulation: cold stress
        clo = wclo
@@ -1636,5 +1895,5 @@
 
        IF ( pmva > 0._wp ) THEN
-
+!
 !--       Case summer clothing insulation: heat load ?
           clo = sclo
@@ -1643,6 +1902,7 @@
           pmv_s = pmva
           IF ( pmva <= 0._wp ) THEN
+!
 !--          Case: comfort achievable by varying clothing insulation 
-!--          Between winter and summer set values
+!            Between winter and summer set values
              CALL iso_ridder ( ta, tmrt, vp, ws, pair, actlev, eta, sclo,      &
                 pmv_s, wclo, pmv_w, eps, pmva, top, ncount, clo )
@@ -1662,5 +1922,5 @@
        ENDIF
     ELSE
-
+!
 !--    First guess: summer clothing insulation: heat load
        clo = sclo
@@ -1669,5 +1929,5 @@
 
        IF ( pmva < 0._wp ) THEN
-
+!
 !--       Case winter clothing insulation: cold stress ?
           clo = wclo
@@ -1677,5 +1937,5 @@
 
           IF ( pmva >= 0._wp ) THEN
-
+!
 !--          Case: comfort achievable by varying clothing insulation 
 !            between winter and summer set values
@@ -1698,10 +1958,11 @@
 
     ENDIF
-
+!
 !-- Determine perceived temperature by regression equation + adjustments
     pmvs = pmva
-    CALL perct_regression ( pmva, clo, perct )
-    ptc = perct
+    CALL perct_regression ( pmva, clo, perct_ij )
+    ptc = perct_ij
     IF ( clo >= 1.75_wp .AND. pmva <= -0.11_wp ) THEN
+!
 !--    Adjust for cold conditions according to Gagge 1986
        CALL dpmv_cold ( pmva, ta, ws, tmrt, nerr_cold, d_pmv )
@@ -1712,13 +1973,14 @@
           pmvs   = -0.11_wp
        ENDIF
-       CALL perct_regression ( pmvs, clo, perct )
+       CALL perct_regression ( pmvs, clo, perct_ij )
     ENDIF
 !     clo_fanger = clo
     clon = clo
-    IF ( clo > 0.5_wp .AND. perct <= 8.73_wp ) THEN
+    IF ( clo > 0.5_wp .AND. perct_ij <= 8.73_wp ) THEN
+!
 !--    Required clothing insulation (ireq) is exclusively defined for 
 !      operative temperatures (top) less 10 (C) for a 
 !      reference wind of 0.2 m/s according to 8.73 (C) for 0.1 m/s
-       clon = ireq_neutral ( perct, ireq_minimal, nerr )
+       clon = ireq_neutral ( perct_ij, ireq_minimal, nerr )
        clo = clon
     ENDIF
@@ -1727,14 +1989,16 @@
     d_std = -99._wp
     IF ( pmva > 0.06_wp .AND. clo <= 0.5_wp ) THEN
+!
 !--    Adjust for warm/humid conditions according to Gagge 1986
        CALL saturation_vapor_pressure ( ta, svp_ta )
        d_pmv  = deltapmv ( pmva, ta, vp, svp_ta, tmrt, ws, nerr )
        pmvs   = pmva + d_pmv
-       CALL perct_regression ( pmvs, clo, perct )
+       CALL perct_regression ( pmvs, clo, perct_ij )
        IF ( sult_lim < 99._wp ) THEN
-          IF ( (perct - ptc) > sult_lim ) sultrieness = .TRUE.
+          IF ( (perct_ij - ptc) > sult_lim ) sultrieness = .TRUE.
+!
 !--       Set factor to threshold for sultriness
           IF ( dgtcstd /= 0_iwp ) THEN
-             d_std = ( ( perct - ptc ) - dgtcm ) / dgtcstd
+             d_std = ( ( perct_ij - ptc ) - dgtcm ) / dgtcstd
           ENDIF
        ENDIF
@@ -1762,13 +2026,15 @@
 
     IF ( ta < 0._wp ) THEN
+!
 !--    ta  < 0 (degC): saturation water vapour pressure over ice
        b = 17.84362_wp
        c = 245.425_wp
     ELSE
+!
 !--    ta >= 0 (degC): saturation water vapour pressure over water
        b = 17.08085_wp
        c = 234.175_wp
     ENDIF
-
+!
 !-- Saturation water vapour pressure
     svp_ta = 6.1078_wp * EXP ( b * ta / ( c + ta ) )
@@ -1788,5 +2054,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables of argument list:
     REAL(wp), INTENT ( IN )  :: ta     !< Ambient temperature (degC)
@@ -1803,5 +2069,5 @@
     REAL(wp), INTENT ( IN )  :: pmv_w    !< Fanger's PMV corresponding to wclo
     REAL(wp), INTENT ( IN )  :: pmv_s    !< Fanger's PMV corresponding to sclo
-
+!
 ! Output variables of argument list:
     REAL(wp), INTENT ( OUT ) :: pmva     !< 0 (set to zero, because clo is evaluated for comfort)
@@ -1814,5 +2080,5 @@
 !           nerr = -2: error = maximum iterations (max_iteration) exceeded 
 !           nerr = -3: error = root not bracketed between sclo and wclo
-
+!
 !-- Type of program variables
     INTEGER(iwp), PARAMETER  ::  max_iteration = 15_iwp       !< max number of iterations
@@ -1831,9 +2097,10 @@
     REAL(wp) ::  sroot       !< sqrt of PMV-guess
     INTEGER(iwp) ::  j       !< running index
-
+!
 !-- Initialise
     nerr    = 0_iwp
-
+!
 !-- Set pmva = 0 (comfort): Root of PMV depending on clothing insulation
+    x_ridder    = bio_fill_value
     pmva        = 0._wp
     clo_lower   = sclo
@@ -1884,4 +2151,5 @@
              y_lower = y_new
           ELSE
+!
 !--          Never get here in x_ridder: singularity in y
              nerr       = -1_iwp
@@ -1895,4 +2163,5 @@
           ENDIF
        ENDDO
+!
 !--    x_ridder exceed maximum iterations
        nerr       = -2_iwp
@@ -1904,4 +2173,5 @@
        x_ridder = clo_upper
     ELSE
+!
 !--    x_ridder not bracketed by u_clo and o_clo
        nerr = -3_iwp
@@ -1919,5 +2189,5 @@
 !> individual and reference environment.
 !------------------------------------------------------------------------------!
- SUBROUTINE perct_regression( pmv, clo, perct )
+ SUBROUTINE perct_regression( pmv, clo, perct_ij )
 
     IMPLICIT NONE
@@ -1926,13 +2196,13 @@
     REAL(wp), INTENT ( IN ) ::  clo   !< clothing insulation index (clo)
 
-    REAL(wp), INTENT ( OUT ) ::  perct   !< perct (degC) corresponding to given PMV / clo
+    REAL(wp), INTENT ( OUT ) ::  perct_ij   !< perct (degC) corresponding to given PMV / clo
 
     IF ( pmv <= -0.11_wp ) THEN
-       perct = 5.805_wp + 12.6784_wp * pmv
+       perct_ij = 5.805_wp + 12.6784_wp * pmv
     ELSE
        IF ( pmv >= + 0.01_wp ) THEN
-          perct = 16.826_wp + 6.163_wp * pmv
+          perct_ij = 16.826_wp + 6.163_wp * pmv
        ELSE
-          perct = 21.258_wp - 9.558_wp * clo
+          perct_ij = 21.258_wp - 9.558_wp * clo
        ENDIF
     ENDIF
@@ -1953,5 +2223,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables of argument list:
     REAL(wp), INTENT ( IN ) ::  ta       !< Ambient air temperature (degC)
@@ -1963,5 +2233,5 @@
     REAL(wp), INTENT ( IN ) ::  actlev   !< Individuals activity level per unit surface area (W/m2)
     REAL(wp), INTENT ( IN ) ::  eta      !< Individuals mechanical work efficiency (dimensionless)
-
+!
 !-- Output variables of argument list:
     REAL(wp), INTENT ( OUT ) ::  pmva    !< Actual Predicted Mean Vote (PMV, 
@@ -1969,5 +2239,5 @@
 !            (ta,tmrt,pa,ws,pair) and individual variables (clo, actlev, eta)
     REAL(wp), INTENT ( OUT ) ::  top     !< operative temperature (degC)
-
+!
 !-- Internal variables
     REAL(wp) ::  f_cl         !< Increase in surface due to clothing    (factor)
@@ -1992,12 +2262,12 @@
     REAL(wp) ::  z6           !< Heat loss through forced convection
     INTEGER(iwp) :: i         !< running index
-
+!
 !-- Clo must be > 0. to avoid div. by 0!
     clo = in_clo
     IF ( clo <= 0._wp ) clo = .001_wp
-
+!
 !-- f_cl = Increase in surface due to clothing
     f_cl = 1._wp + .15_wp * clo
-
+!
 !-- Case of free convection (ws < 0.1 m/s ) not considered
     ws = in_ws
@@ -2005,14 +2275,14 @@
        ws = .1_wp
     ENDIF
-
+!
 !-- Heat_convection = forced convection
     heat_convection = 12.1_wp * SQRT ( ws * pair / 1013.25_wp )
-
+!
 !-- Activity = inner heat produktion per standardized surface
     activity = actlev * ( 1._wp - eta )
-
+!
 !-- T_skin_aver = average skin temperature
     t_skin_aver = 35.7_wp - .0275_wp * activity
-
+!
 !-- Calculation of constants for evaluation below
     bc = .155_wp * clo * 3.96_wp * 10._wp**( -8 ) * f_cl
@@ -2021,5 +2291,5 @@
     dc = ( 1._wp + ec * cc ) / bc
     gc = ( t_skin_aver + bc * ( tmrt + degc_to_k )**4 + ec * cc * ta ) / bc
-
+!
 !-- Calculation of clothing surface temperature (t_clothing) based on
 !   Newton-approximation with air temperature as initial guess
@@ -2029,19 +2299,19 @@
           * dc - gc ) / ( 4._wp * ( t_clothing + degc_to_k )**3 + dc )
     ENDDO
-
+!
 !-- Empiric factor for the adaption of the heat ballance equation
 !   to the psycho-physical scale (Equ. 40 in FANGER)
     z1 = ( .303_wp * EXP ( -.036_wp * actlev ) + .0275_wp )
-
+!
 !-- Water vapour diffution through the skin
     z2 = .31_wp * ( 57.3_wp - .07_wp * activity-pa )
-
+!
 !-- Sweat evaporation from the skin surface
     z3 = .42_wp * ( activity - 58._wp )
-
+!
 !-- Loss of latent heat through respiration
     z4 = .0017_wp * actlev * ( 58.7_wp - pa ) + .0014_wp * actlev *            &
       ( 34._wp - ta )
-
+!
 !-- Loss of radiational heat
     z5 = 3.96e-8_wp * f_cl * ( ( t_clothing + degc_to_k )**4 - ( tmrt +        &
@@ -2052,11 +2322,11 @@
        hr = 0._wp
     ENDIF
-
+!
 !-- Heat loss through forced convection cc*(t_clothing-TT)
     z6 = cc * ( t_clothing - ta )
-
+!
 !-- Predicted Mean Vote
     pmva = z1 * ( activity - z2 - z3 - z4 - z5 - z6 )
-
+!
 !-- Operative temperatur
     top = ( hr * tmrt + heat_convection * ta ) / ( hr + heat_convection )
@@ -2073,5 +2343,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables of argument list:
     REAL(wp),     INTENT ( IN )  :: pmva     !< Actual Predicted Mean Vote (PMV) according to Fanger
@@ -2081,5 +2351,5 @@
     REAL(wp),     INTENT ( IN )  :: tmrt     !< Mean radiant temperature (degC) at screen level
     REAL(wp),     INTENT ( IN )  :: ws       !< Wind speed (m/s) 1 m above ground
-
+!
 !-- Output variables of argument list:
     INTEGER(iwp), INTENT ( OUT ) :: nerr     !< Error status / quality flag
@@ -2088,5 +2358,5 @@
 !            -3 = rel. humidity set to 5 % or 95 %, respectively
 !            -4 = deltapmv set to avoid pmvs < 0
-
+!
 !-- Internal variable types:
     REAL(wp) ::  pmv          !< 
@@ -2142,5 +2412,5 @@
      +1.8686215_wp, +3.4260713_wp, +2.0116185_wp, -0.7777552_wp, -4.6715853_wp,&
      -7.7314281_wp, -11.7602578_wp, -23.5934198_wp /
-
+!
 !-- Test for compliance with regression range
     IF ( pmva < -1.0_wp .OR. pmva > 7.0_wp ) THEN
@@ -2149,8 +2419,8 @@
        nerr = 0_iwp
     ENDIF
-
+!
 !-- Initialise classic PMV
     pmv  = pmva
-
+!
 !-- Water vapour pressure of air 
     p10  = 0.05_wp * svp_ta
@@ -2161,7 +2431,9 @@
        nerr = -3_iwp
        IF ( vp < p10 ) THEN
+!
 !--       Due to conditions of regression: r.H. >= 5 %
           pa = p10
        ELSE
+!
 !--       Due to conditions of regression: r.H. <= 95 %
           pa = p95
@@ -2169,4 +2441,5 @@
     ENDIF
     IF ( pa > 0._wp ) THEN
+!
 !--    Natural logarithm of pa
        apa = LOG ( pa )
@@ -2174,5 +2447,5 @@
        apa = -5._wp
     ENDIF
-
+!
 !-- Ratio actual water vapour pressure to that of a r.H. of 50 %
     pa_p50   = 0.5_wp * svp_ta
@@ -2184,4 +2457,5 @@
        pa_p50 = 0._wp
     ENDIF
+!
 !-- Square root of wind velocity
     IF ( ws >= 0._wp ) THEN
@@ -2190,12 +2464,14 @@
        sqvel = 0._wp
     ENDIF
+!
 !-- Air temperature
 !    ta = ta
 !-- Difference mean radiation to air temperature
     dtmrt = tmrt - ta
-
+!
 !-- Select the valid regression coefficients
     nreg = INT ( pmv )
     IF ( nreg < 0_iwp ) THEN
+!
 !--    value of the FUNCTION in the case pmv <= -1
        deltapmv = 0._wp
@@ -2213,5 +2489,5 @@
        ENDIF
     ENDIF
-
+!
 !-- Regression valid for 0. <= pmv <= 6.
     dpmv_1 =                                                                   &
@@ -2239,15 +2515,18 @@
           + aconst ( nreg + 1_iwp )
     ENDIF
-
+!
 !-- Calculate pmv modification
     deltapmv = ( 1._wp - gew ) * dpmv_1 + gew * dpmv_2
     pmvs = pmva + deltapmv
     IF ( ( pmvs ) < 0._wp ) THEN
+!
 !--    Prevent negative pmv* due to problems with clothing insulation
        nerr = -4_iwp
        IF ( pmvs > -0.11_wp ) THEN
+!
 !--       Threshold from FUNCTION perct_regression for winter clothing insulation
           deltapmv = deltapmv + 0.11_wp
        ELSE
+!
 !--       Set pmvs to "0" for compliance with summer clothing insulation
           deltapmv = -1._wp * pmva
@@ -2266,11 +2545,11 @@
 !> perct. 
 !------------------------------------------------------------------------------!
- SUBROUTINE calc_sultr( perct, dperctm, dperctstd, sultr_res )
+ SUBROUTINE calc_sultr( perct_ij, dperctm, dperctstd, sultr_res )
 
     IMPLICIT NONE
-
+!
 !-- Input of the argument list:
-    REAL(wp), INTENT ( IN )  ::  perct      !< Classical perceived temperature: Base is Fanger's PMV
-
+    REAL(wp), INTENT ( IN )  ::  perct_ij      !< Classical perceived temperature: Base is Fanger's PMV
+!
 !-- Additional output variables of argument list:
     REAL(wp), INTENT ( OUT ) ::  dperctm    !< Mean deviation perct (classical gt) to gt* (rational gt 
@@ -2279,5 +2558,5 @@
 !             determining the significance to perceive sultriness
     REAL(wp), INTENT ( OUT ) ::  sultr_res
-
+!
 !-- Types of coefficients mean deviation: third order polynomial
     REAL(wp), PARAMETER ::  dperctka = +7.5776086_wp
@@ -2285,5 +2564,5 @@
     REAL(wp), PARAMETER ::  dperctkc = +0.0213324_wp
     REAL(wp), PARAMETER ::  dperctkd = -0.00027797237_wp
-
+!
 !-- Types of coefficients mean deviation plus standard deviation
 !   regression coefficients: third order polynomial
@@ -2292,9 +2571,9 @@
     REAL(wp), PARAMETER ::  dperctsc = -0.00054709752_wp
     REAL(wp), PARAMETER ::  dperctsd = +0.0000063714823_wp
-
+!
 !-- Factor to mean standard deviation defining SIGNificance for 
 !   sultriness
     REAL(wp), PARAMETER :: faktor = 1._wp
-
+!
 !-- Initialise
     sultr_res = +99._wp
@@ -2302,15 +2581,18 @@
     dperctstd = 999999._wp
 
-    IF ( perct < 16.826_wp .OR. perct > 56._wp ) THEN
-!--    Unallowed classical PMV/perct
+    IF ( perct_ij < 16.826_wp .OR. perct_ij > 56._wp ) THEN
+!
+!--    Unallowed value of classical perct!
        RETURN
     ENDIF
-
+!
 !-- Mean deviation dependent on perct
-    dperctm = dperctka + dperctkb * perct + dperctkc * perct**2._wp + dperctkd * perct**3._wp
-
+    dperctm = dperctka + dperctkb * perct_ij + dperctkc * perct_ij**2._wp +    &
+       dperctkd * perct_ij**3._wp
+!
 !-- Mean deviation plus its standard deviation
-    dperctstd = dperctsa + dperctsb * perct + dperctsc * perct**2._wp + dperctsd * perct**3._wp
-
+    dperctstd = dperctsa + dperctsb * perct_ij + dperctsc * perct_ij**2._wp +  &
+       dperctsd * perct_ij**3._wp
+!
 !-- Value of the FUNCTION
     sultr_res = dperctm + faktor * dperctstd
@@ -2330,5 +2612,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Type of input arguments
     REAL(wp), INTENT ( IN ) ::  pmva   !< Fanger's classical predicted mean vote
@@ -2336,10 +2618,10 @@
     REAL(wp), INTENT ( IN ) ::  ws     !< Relative wind velocity 1 m above ground (m/s)
     REAL(wp), INTENT ( IN ) ::  tmrt   !< Mean radiant temperature (degC)
-
+!
 !-- Type of output argument
     INTEGER(iwp), INTENT ( OUT ) ::  nerr !< Error indicator: 0 = o.k., +1 = denominator for intersection = 0
     REAL(wp),     INTENT ( OUT ) ::  dpmv_cold_res    !< Increment to adjust pmva according to the results of Gagge's 
 !               2 node model depending on the input
-
+!
 !-- Type of program variables
     REAL(wp) ::  delta_cold(3)
@@ -2352,9 +2634,9 @@
     REAL(wp) ::  sqrt_ws
     INTEGER(iwp) ::  i
-    INTEGER(iwp) ::  j
+!     INTEGER(iwp) ::  j
     INTEGER(iwp) ::  i_bin
-
+!
 !-- Coefficient of the 3 regression lines
-    !     1:const   2:*pmvc  3:*ta      4:*sqrt_ws  5:*dtmrt
+!     1:const   2:*pmvc  3:*ta      4:*sqrt_ws  5:*dtmrt
     coeff(1,1:5) =                                                             &
        (/ +0.161_wp, +0.130_wp, -1.125E-03_wp, +1.106E-03_wp, -4.570E-04_wp /)
@@ -2363,5 +2645,5 @@
     coeff(3,1:5) =                                                             &
        (/ +0.05761_wp, +0.458_wp, -1.829E-02_wp, -5.577E-03_wp, -1.970E-03_wp /)
-
+!
 !-- Initialise
     nerr       = 0_iwp
@@ -2384,10 +2666,11 @@
 
     DO i = 1, 3
+!
 !--    Regression constant for given meteorological variables
-       reg_a(i) = coeff(i, 1) + coeff(i, 3) * ta + coeff(i, 4) *             &
+       reg_a(i) = coeff(i, 1) + coeff(i, 3) * ta + coeff(i, 4) *               &
                   sqrt_ws + coeff(i,5)*dtmrt 
        delta_cold(i) = reg_a(i) + coeff(i, 2) * pmvc
     ENDDO
-
+!
 !-- Intersection points of regression lines in terms of Fanger's PMV
     DO i = 1, 2
@@ -2408,4 +2691,5 @@
        ENDIF
     ENDDO
+!
 !-- Adjust to operative temperature scaled according 
 !   to classical PMV (Fanger)
@@ -2434,5 +2718,5 @@
     INTEGER(iwp)  ::  i, i_bin
 
-!                             range_1     range_2     range_3
+!                                   range_1        range_2        range_3
     DATA (coef(i, 0), i = 1, n_bin) /0.0941540_wp, -0.1506620_wp, -0.0871439_wp/
     DATA (coef(i, 1), i = 1, n_bin) /0.0783162_wp, -1.0612651_wp,  0.1695040_wp/
@@ -2467,25 +2751,25 @@
 !> for perct < 10 (degC)
 !------------------------------------------------------------------------------!
- REAL(wp) FUNCTION ireq_neutral( perct, ireq_minimal, nerr )
+ REAL(wp) FUNCTION ireq_neutral( perct_ij, ireq_minimal, nerr )
 
     IMPLICIT NONE
-
+!
 !-- Type declaration of arguments
-    REAL(wp),     INTENT ( IN )  ::  perct
+    REAL(wp),     INTENT ( IN )  ::  perct_ij
     REAL(wp),     INTENT ( OUT ) ::  ireq_minimal
     INTEGER(iwp), INTENT ( OUT ) ::  nerr
-
+!
 !-- Type declaration for internal varables
     REAL(wp)                     ::  top02
-
+!
 !-- Initialise
     nerr = 0_iwp
-
+!
 !-- Convert perceived temperature from basis 0.1 m/s to basis 0.2 m/s
-    top02 = 1.8788_wp + 0.9296_wp * perct
-
+    top02 = 1.8788_wp + 0.9296_wp * perct_ij
+!
 !-- IREQ neutral conditions (thermal comfort)
     ireq_neutral = 1.62_wp - 0.0564_wp * top02
-
+!
 !-- Regression only defined for perct <= 10 (degC)
     IF ( ireq_neutral < 0.5_wp ) THEN
@@ -2495,5 +2779,5 @@
        ireq_neutral = 0.5_wp
     ENDIF
-
+!
 !-- Minimal required clothing insulation: maximal acceptable body cooling
     ireq_minimal = 1.26_wp - 0.0588_wp * top02
@@ -2523,5 +2807,5 @@
 
     height = height_cm * 100._wp
-
+!
 !-- According to Gehan-George, for children
     IF ( age < 19_iwp ) THEN
@@ -2533,5 +2817,5 @@
        RETURN
     END IF
-
+!
 !-- DuBois D, DuBois EF: A formula to estimate the approximate surface area if 
 !   height and weight be known. In: Arch. Int. Med.. 17, 1916, S. 863?871.
@@ -2598,9 +2882,9 @@
 
  SUBROUTINE ipt_init (age, weight, height, sex, work, actlev, clo,             &
-     ta, vp, ws, tmrt, pair, dt, storage, t_clothing,                         &
+     ta, vp, ws, tmrt, pair, dt, storage, t_clothing,                          &
      ipt )
 
     IMPLICIT NONE
-
+!
 !-- Input parameters
     REAL(wp), INTENT(in) ::  age        !< Persons age          (years)
@@ -2615,5 +2899,5 @@
     REAL(wp), INTENT(in) ::  dt         !< Timestep             (s)
     INTEGER(iwp), INTENT(in)  :: sex    !< Persons sex (1 = male, 2 = female)
-
+!
 !-- Output parameters
     REAL(wp), INTENT(out) ::  actlev
@@ -2622,5 +2906,5 @@
     REAL(wp), INTENT(out) ::  t_clothing
     REAL(wp), INTENT(out) ::  ipt
-
+!
 !-- Internal variables
     REAL(wp), PARAMETER :: eps = 0.0005_wp
@@ -2644,5 +2928,5 @@
     REAL(wp) ::  top
     REAL(wp) ::  a_surf
-    REAL(wp) ::  acti
+!     REAL(wp) ::  acti
     INTEGER(iwp) ::  ncount
     INTEGER(iwp) ::  nerr_cold
@@ -2653,11 +2937,12 @@
     storage = 0._wp
     CALL persdat ( age, weight, height, sex, work, a_surf, actlev )
-
+!
 !-- Initialise
-    t_clothing = -999.0_wp
-    ipt        = -999.0_wp
+    t_clothing = bio_fill_value
+    ipt        = bio_fill_value
     nerr       = 0_wp
     ncount     = 0_wp
     sultrieness    = .FALSE.
+!
 !-- Tresholds: clothing insulation (account for model inaccuracies)
 !-- Summer clothing
@@ -2665,11 +2950,11 @@
 !-- Winter clothing
     wclo     = 1.76267_wp
-
+!
 !-- Decision: firstly calculate for winter or summer clothing
     IF ( ta <= 10._wp ) THEN
-
+!
 !--    First guess: winter clothing insulation: cold stress
        clo = wclo
-       t_clothing = -999.0_wp  ! force initial run
+       t_clothing = bio_fill_value  ! force initial run
        CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,         &
           t_clothing, storage, dt, pmva )
@@ -2677,12 +2962,13 @@
 
        IF ( pmva > 0._wp ) THEN
-
+!
 !--       Case summer clothing insulation: heat load ?            
           clo = sclo
-          t_clothing = -999.0_wp  ! force initial run
+          t_clothing = bio_fill_value  ! force initial run
           CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,      &
              t_clothing, storage, dt, pmva )
           pmv_s = pmva
           IF ( pmva <= 0._wp ) THEN
+!
 !--          Case: comfort achievable by varying clothing insulation 
 !            between winter and summer set values
@@ -2695,5 +2981,5 @@
           ELSE IF ( pmva > 0.06_wp ) THEN
              clo = 0.5_wp
-             t_clothing = -999.0_wp
+             t_clothing = bio_fill_value
              CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,   &
                 t_clothing, storage, dt, pmva )
@@ -2701,5 +2987,5 @@
        ELSE IF ( pmva < -0.11_wp ) THEN
           clo = 1.75_wp
-          t_clothing = -999.0_wp
+          t_clothing = bio_fill_value
           CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,      &
              t_clothing, storage, dt, pmva )
@@ -2707,8 +2993,8 @@
 
     ELSE
-
+!
 !--    First guess: summer clothing insulation: heat load
        clo = sclo
-       t_clothing = -999.0_wp
+       t_clothing = bio_fill_value
        CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,         &
           t_clothing, storage, dt, pmva )
@@ -2716,8 +3002,8 @@
 
        IF ( pmva < 0._wp ) THEN
-
+!
 !--       Case winter clothing insulation: cold stress ?
           clo = wclo
-          t_clothing = -999.0_wp
+          t_clothing = bio_fill_value
           CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,      &
              t_clothing, storage, dt, pmva )
@@ -2725,5 +3011,5 @@
 
           IF ( pmva >= 0._wp ) THEN
-
+!
 !--          Case: comfort achievable by varying clothing insulation 
 !            between winter and summer set values
@@ -2736,5 +3022,5 @@
           ELSE IF ( pmva < -0.11_wp ) THEN
              clo = 1.75_wp
-             t_clothing = -999.0_wp
+             t_clothing = bio_fill_value
              CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,   &
                 t_clothing, storage, dt, pmva )
@@ -2742,5 +3028,5 @@
        ELSE IF ( pmva > 0.06_wp ) THEN
           clo = 0.5_wp
-          t_clothing = -999.0_wp
+          t_clothing = bio_fill_value
           CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,      &
              t_clothing, storage, dt, pmva )
@@ -2748,5 +3034,5 @@
 
     ENDIF
-
+!
 !-- Determine perceived temperature by regression equation + adjustments
     pmvs = pmva
@@ -2754,4 +3040,5 @@
     ptc = ipt
     IF ( clo >= 1.75_wp .AND. pmva <= -0.11_wp ) THEN
+!
 !--    Adjust for cold conditions according to Gagge 1986
        CALL dpmv_cold ( pmva, ta, ws, tmrt, nerr_cold, d_pmv )
@@ -2767,4 +3054,5 @@
     clon = clo
     IF ( clo > 0.5_wp .AND. ipt <= 8.73_wp ) THEN
+!
 !--    Required clothing insulation (ireq) is exclusively defined for 
 !      operative temperatures (top) less 10 (C) for a 
@@ -2777,4 +3065,5 @@
     d_std      = -99._wp
     IF ( pmva > 0.06_wp .AND. clo <= 0.5_wp ) THEN
+!
 !--    Adjust for warm/humid conditions according to Gagge 1986
        CALL saturation_vapor_pressure ( ta, svp_ta )
@@ -2808,5 +3097,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Type of input of the argument list
     REAL(wp), INTENT ( IN )  ::  ta      !< Air temperature             (Â°C)
@@ -2819,12 +3108,12 @@
     REAL(wp), INTENT ( IN )  ::  actlev  !< Internal heat production    (W)
     REAL(wp), INTENT ( IN )  ::  work    !< Mechanical work load        (W)
-
+!
 !-- In and output parameters
     REAL(wp), INTENT (INOUT) ::  storage     !< Heat storage            (W)
     REAL(wp), INTENT (INOUT) ::  t_clothing  !< Clothig temperature     (Â°C)
-
+!
 !-- Type of output of the argument list
     REAL(wp), INTENT ( OUT ) ::  ipt  !< Instationary perceived temperature (Â°C)
-
+!
 !-- Type of internal variables
     REAL(wp) ::  d_pmv
@@ -2841,19 +3130,20 @@
 
     LOGICAL ::  sultrieness
-
+!
 !-- Initialise
-    ipt = -999.0_wp
+    ipt = bio_fill_value
 
     nerr     = 0_iwp
     sultrieness  = .FALSE.
-
+!
 !-- Determine pmv_adjusted for current conditions
     CALL fanger_s_acti ( ta, tmrt, vp, ws, pair, clo, actlev, work,            &
        t_clothing, storage, dt, pmva )
-
+!
 !-- Determine perceived temperature by regression equation + adjustments
     CALL perct_regression ( pmva, clo, ipt )
 
     IF ( clo >= 1.75_wp .AND. pmva <= -0.11_wp ) THEN
+!
 !--    Adjust for cold conditions according to Gagge 1986
        CALL dpmv_cold ( pmva, ta, ws, tmrt, nerr_cold, d_pmv )
@@ -2866,5 +3156,5 @@
        CALL perct_regression ( pmvs, clo, ipt )
     ENDIF
-
+!
 !-- Consider sultriness if appropriate
     ptc = ipt
@@ -2873,4 +3163,5 @@
     d_std      = -99._wp
     IF ( pmva > 0.06_wp .AND. clo <= 0.5_wp ) THEN
+!
 !--    Adjust for warm/humid conditions according to Gagge 1986
        CALL saturation_vapor_pressure ( ta, svp_ta )
@@ -2898,5 +3189,5 @@
 
     IMPLICIT NONE
-
+!
 !--  Input argument types
     REAL(wp), INTENT ( IN )  ::  ta       !< Air temperature          (Â°C)
@@ -2909,5 +3200,5 @@
     REAL(wp), INTENT ( IN )  ::  activity !< Work load                (W/mÂ²)
     REAL(wp), INTENT ( IN )  ::  in_clo   !< Clothing index (clo)     (no dim)
-
+!
 !-- Output argument types
     REAL(wp), INTENT ( OUT ) ::  pmva  !< actual Predicted Mean Vote (no dim)
@@ -2915,5 +3206,5 @@
     REAL(wp), INTENT (INOUT) ::  s  !< storage var. of energy balance (W/m2)
     REAL(wp), INTENT (INOUT) ::  t_cloth  !< clothing temperature (Â°C)
-
+!
 !-- Internal variables
     REAL(wp), PARAMETER  ::  time_equil = 7200._wp
@@ -2928,5 +3219,5 @@
     REAL(wp) ::  gc           !< preliminary result storage
     REAL(wp) ::  t_clothing   !< clothing temperature                   (Â°C)
-    REAL(wp) ::  hr           !< radiational heat resistence
+!     REAL(wp) ::  hr           !< radiational heat resistence
     REAL(wp) ::  clo          !< clothing insulation index              (clo)
     REAL(wp) ::  ws           !< wind speed                             (m/s)
@@ -2946,12 +3237,12 @@
     INTEGER(iwp) ::  niter  !< Running index
 
-
+!
 !-- Clo must be > 0. to avoid div. by 0!
     clo = in_clo
     IF ( clo < 001._wp ) clo = .001_wp
-
+!
 !-- Increase in surface due to clothing
     f_cl = 1._wp + .15_wp * clo
-
+!
 !-- Case of free convection (ws < 0.1 m/s ) not considered
     ws = in_ws
@@ -2959,11 +3250,11 @@
        ws = .1_wp
     ENDIF
-
+!
 !-- Heat_convection = forced convection
     heat_convection = 12.1_wp * SQRT ( ws * pair / 1013.25_wp )
-
+!
 !-- Average skin temperature
     t_skin_aver = 35.7_wp - .0275_wp * activity
-
+!
 !-- Calculation of constants for evaluation below
     bc = .155_wp * clo * 3.96_wp * 10._wp**( -8._wp ) * f_cl
@@ -2972,8 +3263,9 @@
     dc = ( 1._wp + ec * cc ) / bc
     gc = ( t_skin_aver + bc * ( tmrt + 273.2_wp )**4._wp + ec * cc * ta ) / bc
-
+!
 !-- Calculation of clothing surface temperature (t_clothing) based on
 !   newton-approximation with air temperature as initial guess
-    niter = dt
+    niter = INT( dt * 10._wp, KIND=iwp )
+    IF ( niter < 1 ) niter = 1_iwp
     adjustrate = 1._wp - EXP ( -1._wp * ( 10._wp / time_equil ) * dt )
     IF ( adjustrate >= 1._wp ) adjustrate = 1._wp
@@ -2982,5 +3274,5 @@
 
     IF ( t_cloth <= -998.0_wp ) THEN  ! If initial run
-       niter = 3_wp
+       niter = 3_iwp
        adjustrate = 1._wp
        adjustrate_cloth = 1._wp
@@ -2993,35 +3285,35 @@
           dc - gc ) / ( 4._wp * ( t_clothing + 273.2_wp )**3._wp + dc )
     ENDDO
-
+!
 !-- Empiric factor for the adaption of the heat ballance equation
 !   to the psycho-physical scale (Equ. 40 in FANGER)
     z1 = ( .303_wp * EXP ( -.036_wp * actlev ) + .0275_wp )
-
+!
 !-- Water vapour diffution through the skin
     z2 = .31_wp * ( 57.3_wp - .07_wp * activity-pa )
-
+!
 !-- Sweat evaporation from the skin surface
     z3 = .42_wp * ( activity - 58._wp )
-
+!
 !-- Loss of latent heat through respiration
     z4 = .0017_wp * actlev * ( 58.7_wp - pa ) + .0014_wp * actlev *            &
       ( 34._wp - ta )
-
+!
 !-- Loss of radiational heat
     z5 = 3.96e-8_wp * f_cl * ( ( t_clothing + 273.2_wp )**4 - ( tmrt +         &
        273.2_wp )**4 )
-
+!
 !-- Heat loss through forced convection
     z6 = cc * ( t_clothing - ta )
-
+!
 !-- Write together as energy ballance
     en = activity - z2 - z3 - z4 - z5 - z6
-
+!
 !-- Manage storage
     d_s = adjustrate * en + ( 1._wp - adjustrate ) * s
-
+!
 !-- Predicted Mean Vote
     pmva = z1 * d_s
-
+!
 !-- Update storage
     s = d_s
@@ -3041,8 +3333,8 @@
 !------------------------------------------------------------------------------!
 
- SUBROUTINE calculate_pet_static( ta, vpa, v, tmrt, pair, pet )
+ SUBROUTINE calculate_pet_static( ta, vpa, v, tmrt, pair, pet_ij )
 
     IMPLICIT NONE
-
+!
 !-- Input arguments:
     REAL(wp), INTENT( IN ) ::  ta    !< Air temperature             (Â°C)
@@ -3051,8 +3343,8 @@
     REAL(wp), INTENT( IN ) ::  vpa   !< Vapor pressure              (hPa)
     REAL(wp), INTENT( IN ) ::  pair  !< Air pressure                (hPa)
-
+!
 !-- Output arguments:
-    REAL(wp), INTENT ( OUT ) ::  pet  !< PET                         (Â°C)
-
+    REAL(wp), INTENT ( OUT ) ::  pet_ij  !< PET                     (Â°C)
+!
 !-- Internal variables:
     REAL(wp) ::  acl        !< clothing area                        (mÂ²)
